using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace PointSprites
{
/// <summary>
/// Zusammenfassung fr MeshGenerator.
/// </summary>
public class MeshGenerator
{
    byte [,,] meshRawData;
    int cubeLenght = 0;
    int cubeBorder = 0;
    ArrayList verticestemp = new ArrayList();
    ArrayList indicestemp = new ArrayList();
    Device meshdevice;

    public MeshGenerator (Device device)
    {
        meshdevice=device;

        for(int i = 0; i<2; i++)
        {
            InitializeRawData(i);
            GenerateMesh();
            WriteData(i);
            //clean
            verticestemp.Clear();
            indicestemp.Clear();
            //cubeLenght = 0;
            //cubeBorder = 0;
            meshRawData=null;
        }
    }

    public void InitializeRawData (int i)
    {
        FileStream s = new FileStream("frame"+i+".ser", FileMode.Open);
        IFormatter f = new BinaryFormatter();

        meshRawData=f.Deserialize(s)as byte [,,];
        s.Close();
        cubeLenght=meshRawData.GetLength(0);
        cubeBorder=cubeLenght-1;
    }

    public void GenerateMesh ()
    {
        int indicesCounter = 0;
        byte previousCube = 0;
        byte actualCube = 0;

        // Front to Back (Z)
        for(int x = 0; x<cubeLenght; x++)
        {
            for(int y = 0; y<cubeLenght; y++)
            {
                for(int z = 0; z<cubeLenght; z++)
                {
                    if(x==cubeBorder || y==cubeBorder || z==cubeBorder)
                    {
                        actualCube=0;
                    }
                    else
                    {
                        actualCube=meshRawData[x, y, z];
                    }

                    if(previousCube==0)
                    {
                        if(actualCube>0)
                        {
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y+1, z),
                                                                              System.Drawing.Color.Yellow.ToArgb()));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y+1, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y, z), 0));

                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+1);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter+3);
                            indicesCounter+=4;
                        }
                    }

                    if(actualCube==0)
                    {
                        if(previousCube>0)
                        {
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y+1, z),
                                                                              System.Drawing.Color.Blue.ToArgb()));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y+1, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z), 0));

                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+1);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter+3);
                            indicesCounter+=4;
                        }
                    }

                    previousCube=actualCube;
                }
            }
        }

        // Bottom to Top (Y)
        for(int x = 0; x<cubeLenght; x++)
        {
            for(int z = 0; z<cubeLenght; z++)
            {
                for(int y = 0; y<cubeLenght; y++)
                {
                    if(x==cubeBorder || y==cubeBorder || z==cubeBorder)
                    {
                        actualCube=0;
                    }
                    else
                    {
                        actualCube=meshRawData[x, y, z];
                    }

                    if(previousCube==0)
                    {
                        if(actualCube>0)
                        {
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y, z),
                                                                              System.Drawing.Color.Green.ToArgb()));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z+1), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y, z+1), 0));

                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+1);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter+3);
                            indicesCounter+=4;
                        }
                    }

                    if(actualCube==0)
                    {
                        if(previousCube>0)
                        {
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y, z+1),
                                                                              System.Drawing.Color.Red.ToArgb()));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z+1), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x+1, y, z), 0));

                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+1);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter+3);
                            indicesCounter+=4;
                        }
                    }

                    previousCube=actualCube;
                }
            }
        }

        // Left to Right (X)
        for(int z = 0; z<cubeLenght; z++)
        {
            for(int y = 0; y<cubeLenght; y++)
            {
                for(int x = 0; x<cubeLenght; x++)
                {
                    if(x==cubeBorder || y==cubeBorder || z==cubeBorder)
                    {
                        actualCube=0;
                    }
                    else
                    {
                        actualCube=meshRawData[x, y, z];
                    }

                    if(previousCube==0)
                    {
                        if(actualCube>0)
                        {
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z),
                                                                              System.Drawing.Color.Gray.ToArgb()));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y+1, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y+1, z+1), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z+1), 0));

                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+1);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter+3);
                            indicesCounter+=4;
                        }
                    }

                    if(actualCube==0)
                    {
                        if(previousCube>0)
                        {
                            verticestemp.Add(
                                new CustomVertex.PositionColored(new Vector3(x, y, z+1),
                                                                 System.Drawing.Color.BlueViolet.ToArgb()));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y+1, z+1), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y+1, z), 0));
                            verticestemp.Add(new CustomVertex.PositionColored(new Vector3(x, y, z), 0));

                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+1);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter);
                            indicestemp.Add(indicesCounter+2);
                            indicestemp.Add(indicesCounter+3);
                            indicesCounter+=4;
                        }
                    }

                    previousCube=actualCube;
                }
            }
        }
    }

    public void WriteData (int i)
    {
        Mesh surfacemesh = new Mesh(verticestemp.Count/2,                           // 12 faces
                                    verticestemp.Count,                             // 8 vertices
                                    MeshFlags.Use32Bit,                             // no flags
                                    VertexFormats.Position | VertexFormats.Diffuse, // Position information only
                                    meshdevice);

        surfacemesh.SetVertexBufferData(verticestemp.ToArray(typeof(CustomVertex.PositionColored)), LockFlags.None);
        surfacemesh.SetIndexBufferData(indicestemp.ToArray(typeof(int)), LockFlags.None);

        int []adjacency = new int[surfacemesh.NumberFaces*3];
        surfacemesh.GenerateAdjacency(0.01f, adjacency);

        /*
                    surfacemesh.OptimizeInPlace(MeshFlags.OptimizeVertexCache | MeshFlags.OptimizeAttrSort | MeshFlags.OptimizeVertexCache, adjacency);
                    int []adjacencyopt = new int[surfacemesh.NumberFaces * 3];
                    surfacemesh.GenerateAdjacency(0.01f, adjacencyopt);
                    //simplifiedMesh = Mesh.Simplify(meshgenerated, adjacencyopt, null, 6, MeshFlags.SimplifyFace);
        */

        ExtendedMaterial []mat = new ExtendedMaterial[1];
        surfacemesh.Save(@"frame"+i+".x", adjacency, mat, XFileFormat.Text);
    }
}
}
