using System;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Threading;
using System.IO;

namespace PointSprites
{
/// <summary>
/// Application class. The base class (GraphicsSample) provides the generic 
/// functionality needed in all Direct3D samples. MyGraphicsSample adds 
/// functionality specific to this sample program.
/// </summary>
public class MyGraphicsSample : GraphicsSample
{
    public struct PointVertex
    {
        public Vector3 v;
        public int color;
    //public static readonly VertexFormats Format =  VertexFormats.Position | VertexFormats.Diffuse;
    } ;

    PointVertex []vertices;

    public enum ParticleColors
        {
        White,
        Yellow,
        NumColors
        };

    public System.Drawing.Color []colors = {System.Drawing.Color.White, System.Drawing.Color.Yellow, };

    ParticleColors particleColor = ParticleColors.White;

    /// <summary>
    /// Custom vertex types
    /// </summary>
    int numParticlesToRender = 0;
    float a = 0;
    float b = 0;
    int i = 0;
    //int j = 0;
    //int g = 0;
    int f = 0;
    int q = 0;
    int d = 1;

    Mesh []mesharr = new Mesh[15];

    private Mesh meshload = null;
    private Mesh meshgen = null;
    private Mesh pyramid = null;
    private Mesh meshclean = null;
    private Mesh simplifiedMesh = null;
    private Mesh meshgenerated = null;
    private Mesh meshgeniextern = null;
    private Mesh surfacemesh = null;

    private Mesh mesh0 = null;
    private Mesh mesh1 = null;
    private Mesh mesh2 = null;
    private Mesh mesh3 = null;
    private Mesh mesh4 = null;
    private Mesh mesh5 = null;
    private Mesh mesh6 = null;
    private Mesh mesh7 = null;
    private Mesh mesh8 = null;
    private Mesh mesh9 = null;
    private Mesh mesh10 = null;
    private Mesh mesh11 = null;
    private Mesh mesh12 = null;
    private Mesh mesh13 = null;
    private Mesh mesh14 = null;
    private Mesh mesh15 = null;
    private Mesh mesh16 = null;
    private Mesh mesh17 = null;
    private Mesh mesh18 = null;
    private Mesh mesh19 = null;
    private Mesh mesh20 = null;

    private VertexBuffer vertexBuffer0 = null;
    private VertexBuffer vertexBuffer1 = null;
    private VertexBuffer vertexBuffer2 = null;
    private VertexBuffer vertexBuffer3 = null;
    private VertexBuffer vertexBuffer4 = null;
    private VertexBuffer vertexBuffer5 = null;
    private VertexBuffer vertexBuffer6 = null;
    private VertexBuffer vertexBuffer7 = null;
    private VertexBuffer vertexBuffer8 = null;
    private VertexBuffer vertexBuffer9 = null;
    private VertexBuffer vertexBuffer10 = null;
    private VertexBuffer vertexBuffer11 = null;
    private VertexBuffer vertexBuffer12 = null;
    private VertexBuffer vertexBuffer13 = null;
    private VertexBuffer vertexBuffer14 = null;
    private VertexBuffer vertexBuffer15 = null;
    private VertexBuffer vertexBuffer16 = null;
    private VertexBuffer vertexBuffer17 = null;
    private VertexBuffer vertexBuffer18 = null;
    private VertexBuffer vertexBuffer19 = null;
    private VertexBuffer vertexBuffer20 = null;

    private GraphicsFont drawingFont = null;      // Font for drawing text
    private GraphicsFont drawingFontSmall = null; // Font for drawing text

    // Ground stuff

    // Particle stuff
    //Texture particleTexture = null;

    private byte []keyValues = new byte[256];
    bool canDrawReflection = false;
    bool canDoALphaBlend = false;
    bool shouldDrawHelp = false;

    // Variables for determining view position
    Vector3 position;
    Vector3 velocity;
    float yaw = 0.0f;
    float yawVelocity = 0.0f;
    float pitch = 0.0f;
    float pitchVelocity = 0.0f;
    Matrix viewMatrix;
    Matrix orientationMatrix;

    /// <summary>
    /// Application constructor. Sets attributes for the app.
    /// </summary>
    public MyGraphicsSample ()
    {
        Console.WriteLine("MyGraphicsSample");
        // Set the window text
        this.Text="3D Cellular Automata Simulator";

        try
        {
            // Load the icon from our resources
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(this.GetType());
            this.Icon=((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
        }
        catch
        {
            // It's no big deal if we can't load our icons, but try to load the embedded one
            try
            {
                this.Icon=new System.Drawing.Icon(this.GetType(), "directx.ico");
            }
            catch
            {
            }
        }

        drawingFont=new GraphicsFont("Arial", System.Drawing.FontStyle.Bold);
        drawingFontSmall=new GraphicsFont("Arial", System.Drawing.FontStyle.Bold, 9);
        enumerationSettings.AppUsesDepthBuffer=true;

        position=new Vector3(16.0f, 16.0f, -50.0f);
        velocity=new Vector3(0.0f, 0.0f, 0.0f);
        yaw=0.03f;
        yawVelocity=0.0f;
        pitch=0.0f;
        pitchVelocity=0.0f;
        viewMatrix=Matrix.Translation(0.0f, 0.0f, 10.0f);
        orientationMatrix=Matrix.Translation(0.0f, 0.0f, 0.0f);

        // Set up our event handlers
        this.KeyDown+=new System.Windows.Forms.KeyEventHandler(this.OnPrivateKeyDown);
        this.KeyUp+=new System.Windows.Forms.KeyEventHandler(this.OnPrivateKeyUp);

        numParticlesToRender=8000000;
        a=20.0f;
        b=0.1f;
    //vertices = new PointVertex[numParticlesToRender];
    //CreateData();
    //Console.WriteLine("Finished");

    }

    public void GenerateMesh (Device device)
    {
        MeshGenerator meschi = new MeshGenerator(device);
    }

    /*
    public void MeshGenerator(Device device)
    {
        byte[,,] meshRawData = new byte[3,3,3];
        byte previousCube=0;
        byte actualCube=0;
        CustomVertex.PositionColored[] vertices = new CustomVertex.PositionColored[216];
        short[] indices = new short[324];
        Device meshdevice = device;

        meshRawData[0,0,0] = 0;
        meshRawData[1,0,0] = 1;
        meshRawData[2,0,0] = 0;
        meshRawData[0,1,0] = 1;
        meshRawData[1,1,0] = 1;
        meshRawData[2,1,0] = 1;
        meshRawData[0,2,0] = 0;
        meshRawData[1,2,0] = 1;
        meshRawData[2,2,0] = 0;
        meshRawData[0,0,1] = 1;
        meshRawData[1,0,1] = 1;
        meshRawData[2,0,1] = 1;
        meshRawData[0,1,1] = 1;
        meshRawData[1,1,1] = 1;
        meshRawData[2,1,1] = 1;
        meshRawData[0,2,1] = 1;
        meshRawData[1,2,1] = 1;
        meshRawData[2,2,1] = 1;
        meshRawData[0,0,2] = 0;
        meshRawData[1,0,2] = 1;
        meshRawData[2,0,2] = 0;
        meshRawData[0,1,2] = 1;
        meshRawData[1,1,2] = 1;
        meshRawData[2,1,2] = 1;
        meshRawData[0,2,2] = 0;
        meshRawData[1,2,2] = 1;
        meshRawData[2,2,2] = 0;

        int v=0;
        int i=0;
        for(int x=0; x<4; x++)
        {
            for(int y=0; y<4; y++)
            {
                for(int z=0; z<4; z++)
                {
                    if(x==3 || y==3 || z==3)
                    {
                        actualCube=0;
                    }
                    else
                    {
                        actualCube = meshRawData[x,y,z];
                    }
                    if(previousCube==0)
                    {
                        if(actualCube>0)
                        {
                            //byte colorValue = meshRawData[x,y,z];
                            vertices[v].SetPosition(new Vector3(x, y, z));
                            vertices[v].Color = System.Drawing.Color.Yellow.ToArgb();
                            indices[i] = (short)v;
                            indices[i+3] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i  + " i2:" + (i+3) + "   x:" + x + " y:" + y + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + "   x:" + x + " y:" + (y+1) + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y+1, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + " i2:" + (i+2) + "   x:" + x + " y:" + (y+1) + " z:" + (z+1));
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y+1, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i2:" + (i+2) + "   x:" + x + " y:" + y + " z:" + (z+1));
                            v++;
                            i+=3;
                            //break;
                        }
                    }
                    if(actualCube==0)
                    {
                        if(previousCube>0)
                        {
                            vertices[v].SetPosition(new Vector3(x+1, y, z));
                            vertices[v].Color = System.Drawing.Color.Blue.ToArgb();
                            indices[i] = (short)v;
                            indices[i+3] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i  + " i2:" + (i+3) + "   x:" + x + " y:" + y + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + "   x:" + x + " y:" + (y+1) + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y+1, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + " i2:" + (i+2) + "   x:" + x + " y:" + (y+1) + " z:" + (z+1));
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y+1, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i2:" + (i+2) + "   x:" + x + " y:" + y + " z:" + (z+1));
                            v++;
                            i+=3;
                        }
                    }
                    previousCube = actualCube;
                }
            }
        }

        for(int x=0; x<4; x++)
        {
            for(int z=0; z<4; z++)
            {
                for(int y=0; y<4; y++)
                {
                    if(x==3 || y==3 || z==3)
                    {
                        actualCube=0;
                    }
                    else
                    {
                        actualCube = meshRawData[x,y,z];
                    }
                    if(previousCube==0)
                    {
                        if(actualCube>0)
                        {

                            vertices[v].SetPosition(new Vector3(x, y, z+1));
                            vertices[v].Color = System.Drawing.Color.Blue.ToArgb();
                            indices[i] = (short)v;
                            indices[i+3] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i  + " i2:" + (i+3) + "   x:" + x + " y:" + y + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y, z+1));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + "   x:" + x + " y:" + (y+1) + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + " i2:" + (i+2) + "   x:" + x + " y:" + (y+1) + " z:" + (z+1));
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i2:" + (i+2) + "   x:" + x + " y:" + y + " z:" + (z+1));
                            v++;
                            i+=3;
                            
                        }
                    }
                    if(actualCube==0)
                    {
                        if(previousCube>0)
                        {
                            //byte colorValue = meshRawData[x,y,z];
                            vertices[v].SetPosition(new Vector3(x, y, z));
                            vertices[v].Color = System.Drawing.Color.Yellow.ToArgb();
                            indices[i] = (short)v;
                            indices[i+3] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i  + " i2:" + (i+3) + "   x:" + x + " y:" + y + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + "   x:" + x + " y:" + (y+1) + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x+1, y, z+1));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + " i2:" + (i+2) + "   x:" + x + " y:" + (y+1) + " z:" + (z+1));
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y, z+1));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i2:" + (i+2) + "   x:" + x + " y:" + y + " z:" + (z+1));
                            v++;
                            i+=3;
                            //break;
                        }
                    }
                    previousCube = actualCube;
                }
            }

        }
        for(int z=0; z<4; z++)
        {
            for(int y=0; y<4; y++)
            {
                for(int x=0; x<4; x++)
                {
                    if(x==3 || y==3 || z==3)
                    {
                        actualCube=0;
                    }
                    else
                    {
                        actualCube = meshRawData[x,y,z];
                    }
                    if(previousCube==0)
                    {
                        if(actualCube>0)
                        {
                            //byte colorValue = meshRawData[x,y,z];
                            vertices[v].SetPosition(new Vector3(x, y, z));
                            vertices[v].Color = System.Drawing.Color.Yellow.ToArgb();
                            indices[i] = (short)v;
                            indices[i+3] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i  + " i2:" + (i+3) + "   x:" + x + " y:" + y + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y+1, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + "   x:" + x + " y:" + (y+1) + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y+1, z+1));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + " i2:" + (i+2) + "   x:" + x + " y:" + (y+1) + " z:" + (z+1));
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y, z+1));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i2:" + (i+2) + "   x:" + x + " y:" + y + " z:" + (z+1));
                            v++;
                            i+=3;
                            //break;
                        }
                    }
                    if(actualCube==0)
                    {
                        if(previousCube>0)
                        {
                            vertices[v].SetPosition(new Vector3(x, y, z+1));
                            vertices[v].Color = System.Drawing.Color.Blue.ToArgb();
                            indices[i] = (short)v;
                            indices[i+3] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i  + " i2:" + (i+3) + "   x:" + x + " y:" + y + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y+1, z+1));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + "   x:" + x + " y:" + (y+1) + " z:" + z);
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y+1, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i] = (short)v;
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i:" + i + " i2:" + (i+2) + "   x:" + x + " y:" + (y+1) + " z:" + (z+1));
                            v++;
                            i++;
                            vertices[v].SetPosition(new Vector3(x, y, z));
                            vertices[v].Color = System.Drawing.Color.Transparent.ToArgb();
                            indices[i+2] = (short)v;
                            Console.WriteLine("v:" + v + " i2:" + (i+2) + "   x:" + x + " y:" + y + " z:" + (z+1));
                            v++;
                            i+=3;
                        }
                    }
                    previousCube = actualCube;
                }
            }
        }

        // Create new cube mesh with: 
        surfacemesh = new Mesh(
            108,                                   // 12 faces
            216,                                   // 8 vertices
            MeshFlags.Managed,                    // no flags
            VertexFormats.Position | VertexFormats.Diffuse, // Position information only
            meshdevice);

        surfacemesh.VertexBuffer.SetData(vertices, 0, LockFlags.None);
        surfacemesh.IndexBuffer.SetData(indices, 0, LockFlags.None);

        /*
        int []adjacency = new int[surfacemesh.NumberFaces * 3];
        surfacemesh.GenerateAdjacency(0.01f, adjacency);

        
            meshgenerated.OptimizeInPlace(MeshFlags.OptimizeVertexCache | MeshFlags.OptimizeAttrSort | MeshFlags.OptimizeVertexCache, adjacency);

            int []adjacencyopt = new int[meshgenerated.NumberFaces * 3];
            meshgenerated.GenerateAdjacency(0, adjacencyopt);
            

        //simplifiedMesh = Mesh.Simplify(meshgenerated, adjacency, null, 6, MeshFlags.SimplifyFace);
        ExtendedMaterial []mat = new ExtendedMaterial[1]; // todo!!
        surfacemesh.Save(@"frame.x", adjacency, mat, XFileFormat.Text);
        
    }
    */

    private void LoadMesh ()
    {
        ExtendedMaterial []mtrl;

        TextWriter tw = new StreamWriter(@"c:\log.log");

        // Load our mesh
        for(int i = 0; i<=14; i++)
        {
            try
            {
                mesharr[i]=Mesh.FromFile(@"frame"+i+".x", MeshFlags.Managed, device, out mtrl);
                tw.WriteLine("mesh "+i+" loaded.");
                tw.Flush();
            }
            catch (Exception ex)
            {
                tw.WriteLine(ex);
                tw.Flush();
            }
        }

        tw.Close();
    }

    private void GenerateeMesh (Device device)
    {
        //MeshGenerator meshgeni = new MeshGenerator(device);
        /*
        CustomVertex.PositionOnly []vertices =
        {
            new CustomVertex.PositionOnly(0.0f, 0.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(1.0f, 0.0f, 0.0f),   // 1
            new CustomVertex.PositionOnly(2.0f, 0.0f, 0.0f),
            new CustomVertex.PositionOnly(3.0f, 0.0f, 0.0f), // 0

            new CustomVertex.PositionOnly(0.0f, 1.0f, 0.0f),   // 1
            new CustomVertex.PositionOnly(1.0f, 1.0f, 0.0f), 
            new CustomVertex.PositionOnly(2.0f, 1.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(3.0f, 1.0f, 0.0f),   // 1

            new CustomVertex.PositionOnly(0.0f, 2.0f, 0.0f),
            new CustomVertex.PositionOnly(1.0f, 2.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(2.0f, 2.0f, 0.0f),   // 1
            new CustomVertex.PositionOnly(3.0f, 2.0f, 0.0f),
            
            new CustomVertex.PositionOnly(0.0f, 3.0f, 0.0f),
            new CustomVertex.PositionOnly(1.0f, 3.0f, 0.0f),
            new CustomVertex.PositionOnly(2.0f, 3.0f, 0.0f),
            new CustomVertex.PositionOnly(3.0f, 3.0f, 0.0f),
        };*/

        CustomVertex.PositionColored []vertices = new CustomVertex.PositionColored[15];

        vertices[0].SetPosition(new Vector3(0.0f, 0.0f, 0.0f));
        vertices[0].Color=System.Drawing.Color.Blue.ToArgb();
        vertices[1].SetPosition(new Vector3(1.0f, 0.0f, 0.0f));
        vertices[1].Color=System.Drawing.Color.Blue.ToArgb();
        vertices[2].SetPosition(new Vector3(2.0f, 0.0f, 0.0f));
        vertices[2].Color=System.Drawing.Color.Blue.ToArgb();
        vertices[3].SetPosition(new Vector3(3.0f, 0.0f, 0.0f));
        vertices[3].Color=System.Drawing.Color.Blue.ToArgb();

        vertices[4].SetPosition(new Vector3(0.0f, 1.0f, 0.0f));
        vertices[4].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[5].SetPosition(new Vector3(1.0f, 1.0f, 0.0f));
        vertices[5].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[6].SetPosition(new Vector3(2.0f, 1.0f, 0.0f));
        vertices[6].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[7].SetPosition(new Vector3(3.0f, 1.0f, 0.0f));
        vertices[7].Color=System.Drawing.Color.Yellow.ToArgb();

        vertices[8].SetPosition(new Vector3(0.0f, 2.0f, 0.0f));
        vertices[8].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[9].SetPosition(new Vector3(1.0f, 2.0f, 0.0f));
        vertices[9].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[10].SetPosition(new Vector3(2.0f, 2.0f, 0.0f));
        vertices[10].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[11].SetPosition(new Vector3(3.0f, 2.0f, 0.0f));
        vertices[11].Color=System.Drawing.Color.Yellow.ToArgb();

        vertices[12].SetPosition(new Vector3(0.0f, 3.0f, 0.0f));
        vertices[12].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[13].SetPosition(new Vector3(1.0f, 3.0f, 0.0f));
        vertices[13].Color=System.Drawing.Color.Yellow.ToArgb();
        vertices[14].SetPosition(new Vector3(2.0f, 3.0f, 0.0f));
        vertices[14].Color=System.Drawing.Color.Yellow.ToArgb();
        //vertices[15].SetPosition(new Vector3(3.0f, 3.0f, 0.0f));
        //vertices[15].Color = System.Drawing.Color.Yellow.ToArgb();

        // Set up the 8 corners of the cube

        // Set up the index information for the 12 faces
        short []indices = new short[48];

        indices[0]=0;
        indices[1]=1;
        indices[2]=4;

        indices[3]=1;
        indices[4]=5;
        indices[5]=4;

        indices[6]=1;
        indices[7]=2;
        indices[8]=5;

        indices[9]=2;
        indices[10]=6;
        indices[11]=5;

        indices[12]=2;
        indices[13]=3;
        indices[14]=6;

        indices[15]=3;
        indices[16]=7;
        indices[17]=6;

        indices[18]=4;
        indices[19]=5;
        indices[20]=8;

        indices[21]=5;
        indices[22]=9;
        indices[23]=8;

        indices[24]=5;
        indices[25]=6;
        indices[26]=9;

        indices[27]=6;
        indices[28]=10;
        indices[29]=9;

        indices[30]=6;
        indices[31]=7;
        indices[32]=10;

        indices[33]=7;
        indices[34]=11;
        indices[35]=10;

        indices[36]=8;
        indices[37]=9;
        indices[38]=12;

        indices[39]=9;
        indices[40]=13;
        indices[41]=12;

        indices[42]=9;
        indices[43]=10;
        indices[44]=13;

        indices[45]=10;
        indices[46]=14;
        indices[47]=13;

        /*indices[48] = 10;
        indices[49] = 11;
        indices[50] = 14;

        indices[51] = 11;
        indices[52] = 15;
        indices[53] = 14;*/

        // Create new cube mesh with: 
        meshgenerated=new Mesh(16,                                             // 12 faces
                               15,                                             // 8 vertices
                               MeshFlags.Managed,                              // no flags
                               VertexFormats.Position | VertexFormats.Diffuse, // Position information only
                               device);

        meshgenerated.VertexBuffer.SetData(vertices, 0, LockFlags.None);
        meshgenerated.IndexBuffer.SetData(indices, 0, LockFlags.None);
        Console.WriteLine(meshgenerated.NumberFaces+" : "+meshgenerated.NumberVertices);

        meshgeniextern=new Mesh(16,                                             // 12 faces
                                15,                                             // 8 vertices
                                MeshFlags.Managed,                              // no flags
                                VertexFormats.Position | VertexFormats.Diffuse, // Position information only
                                device);

        //meshgeniextern.VertexBuffer.SetData(meshgeni.vertices, 0, LockFlags.None);
        //meshgeniextern.IndexBuffer.SetData(meshgeni.indices, 0, LockFlags.None);
        Console.WriteLine(meshgeniextern.NumberFaces+" : "+meshgeniextern.NumberVertices);

        int []adjacency = new int[meshgenerated.NumberFaces*3];
        meshgenerated.GenerateAdjacency(0, adjacency);

        /*
        meshgenerated.OptimizeInPlace(MeshFlags.OptimizeVertexCache | MeshFlags.OptimizeAttrSort | MeshFlags.OptimizeVertexCache, adjacency);

        int []adjacencyopt = new int[meshgenerated.NumberFaces * 3];
        meshgenerated.GenerateAdjacency(0, adjacencyopt);
        */

        //simplifiedMesh = Mesh.Simplify(meshgenerated, adjacency, null, 6, MeshFlags.SimplifyFace);

        ExtendedMaterial []mat = new ExtendedMaterial[1]; // todo!!
        meshgenerated.Save(@"tiny.x", adjacency, mat, XFileFormat.Text);
    }

    public void GenMeshes (Device device)
    {
        CustomVertex.PositionOnly []vertices =
        {
            new CustomVertex.PositionOnly(0.0f, 0.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(1.0f, 0.0f, 0.0f), // 1
            new CustomVertex.PositionOnly(2.0f, 0.0f, 0.0f),
            new CustomVertex.PositionOnly(3.0f, 0.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(0.0f, 1.0f, 0.0f), // 1
            new CustomVertex.PositionOnly(1.0f, 1.0f, 0.0f),
            new CustomVertex.PositionOnly(2.0f, 1.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(3.0f, 1.0f, 0.0f), // 1
            new CustomVertex.PositionOnly(0.0f, 2.0f, 0.0f),
            new CustomVertex.PositionOnly(1.0f, 2.0f, 0.0f), // 0
            new CustomVertex.PositionOnly(2.0f, 2.0f, 0.0f), // 1
            new CustomVertex.PositionOnly(3.0f, 2.0f, 0.0f),
            new CustomVertex.PositionOnly(0.0f, 3.0f, 0.0f),
            new CustomVertex.PositionOnly(1.0f, 3.0f, 0.0f),
            new CustomVertex.PositionOnly(2.0f, 3.0f, 0.0f),
            new CustomVertex.PositionOnly(3.0f, 3.0f, 0.0f),
        };

        // Set up the 8 corners of the cube

        // Set up the index information for the 12 faces
        /*short []indices = new short[]
        {
        // Left faces
        0,1,4,
        1,5,4,
        1,2,5,
        2,6,5,
        2,3,6,
        3,7,6,
        4,5,8,
        5,9,8,
        5,6,9,
        6,10,9,
        6,7,10,
        7,11,10,
        8,9,12,
        9,13,12,
        9,10,13,
        10,14,13,
        10,11,14,
        11,15,14
        };
        */

        short []indices = new short[]
        {
        // Left faces
            0, 1, 4,  1, 5,  4,  1, 2, 5,  2, 6,  5,  2, 3,  6,  3,  7,  6,  4,  5,  8,  5,  9,  8, 5, 6, 9, 6, 10, 9,
            6, 7, 10, 7, 11, 10, 8, 9, 12, 9, 13, 12, 9, 10, 13, 10, 14, 13, 10, 11, 14, 11, 15, 14
        };

        // Create new cube mesh with: 
        meshgen=new Mesh(18,                               // 12 faces
                         16,                               // 8 vertices
                         MeshFlags.Managed,                // no flags
                         CustomVertex.PositionOnly.Format, // Position information only
                         device);

        meshgen.VertexBuffer.SetData(vertices, 0, LockFlags.None);
        meshgen.IndexBuffer.SetData(indices, 0, LockFlags.None);

    /*
           int []adjacency = new int[meshgen.NumberFaces * 3];
            meshgen.GenerateAdjacency(0.01F, adjacency);
                    for (int i=0; i<adjacency.GetLength(0);i++)
            {
                Console.WriteLine(adjacency[i]);
            }
            Console.WriteLine("ddd");
            //meshgen.OptimizeInPlace(MeshFlags.OptimizeVertexCache | MeshFlags.OptimizeAttrSort | MeshFlags.OptimizeVertexCache, adjacency);
    
            int []adjacency2 = new int[meshgen.NumberFaces * 3];
            meshgen.GenerateAdjacency(0.01F, adjacency2);
            for (int i=0; i<adjacency2.GetLength(0);i++)
            {
                Console.WriteLine(adjacency2[i]);
            }
            Console.WriteLine("fff");
            int []adjacency3;
            meshclean = Mesh.Clean(meshgen, adjacency2, out adjacency3);
        
            for (int i=0; i<adjacency3.GetLength(0);i++)
            {
                Console.WriteLine(adjacency3[i]);
            }
    Console.WriteLine("Before: {0}", meshclean.NumberVertices);
            meshclean.WeldVertices(0, new WeldEpsilons(), null, null);
            Console.WriteLine("Before: {0}", meshclean.NumberVertices);
    
    AttributeWeights weights = new AttributeWeights();
            weights.Position= 2.0f;
            weights.Boundary = 0.0f;
            weights.Normal = 2.0f;
            weights.Diffuse = 0.0f;
            weights.Specular = 0.0f;
            weights.Binormal = 0.0f;
            weights.Tangent = 0.0f;
            weights.TextureCoordinate = new float[] {0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f};
    
    
    
            simplifiedMesh = Mesh.Simplify(meshclean, adjacency, null, 4, MeshFlags.SimplifyFace);
            Console.WriteLine("Number of vertices in original mesh: {0}", meshclean.NumberVertices);
            Console.WriteLine("Number of vertices in simplified mesh: {0}", simplifiedMesh.NumberVertices);
            //meshgen.OptimizeInPlace(MeshFlags.OptimizeCompact, adjacency2);
           // meshgen.GenerateAdjacency(0.01F, adjacency);
           // meshgen.OptimizeInPlace(MeshFlags.OptimizeVertexCache, adjacency);
            //numSubSets = mesh.GetAttributeTable().Length;
            //ExtendedMaterial []mat;// = new ExtendedMaterial[1]; // todo!!
            //meshgen.Save(@"tiny.x", adjacency, mat, XFileFormat.Text);
            */
    }

    private void MakePyramide (Device device)
    {
        CustomVertex.PositionColored []vertices =
        {
            new CustomVertex.PositionColored(-1f, 0f, -1f, System.Drawing.Color.Green.ToArgb()),
            new CustomVertex.PositionColored(1f, 0f, -1f, System.Drawing.Color.White.ToArgb()),
            new CustomVertex.PositionColored(1f, 0f, 1f, System.Drawing.Color.Yellow.ToArgb()),
            new CustomVertex.PositionColored(-1f, 0f, 1f, System.Drawing.Color.Red.ToArgb()),
            new CustomVertex.PositionColored(0f, 1.7f, 0f, System.Drawing.Color.Blue.ToArgb())
        };

        short []indices =
        {
            0,
            1,
            3,
            1,
            2,
            3,
            0,
            4,
            1,
            3,
            4,
            0,
            2,
            4,
            3,
            1,
            4,
            2
        };

        pyramid=new Mesh(indices.Length/3, vertices.Length, MeshFlags.Managed, CustomVertex.PositionColored.Format,
                         device);
        pyramid.VertexBuffer.SetData(vertices, 0, LockFlags.None);
        pyramid.IndexBuffer.SetData(indices, 0, LockFlags.None);
    }

    /// <summary>
    /// Called once per frame, the call is the entry point for 3d rendering. This 
    /// function sets up render states, clears the viewport, and renders the scene.
    /// </summary>
    protected override void Render ()
    {
        // Update the camera here rather than in FrameMove() so you can
        // move the camera even when the scene is paused
        UpdateCamera();

        device.BeginScene();

        // Clear the viewport
        device.Clear(ClearFlags.Target | ClearFlags.ZBuffer, 0, 1.0f, 0);

        device.Transform.View=viewMatrix;
        /*
        device.SetTexture(0, groundTexture);
        device.VertexFormat = ColorVertex.Format;
        device.SetStreamSource(0, groundVertexBuffer, 0);
        device.Indices = groundIndexBuffer;
        device.DrawIndexedPrimitives(PrimitiveType.TriangleList, 0, 0, numGroundVertices, 0, numGroundIndices/3);

*/
        // Draw particles
        //device.RenderState.ZBufferWriteEnable = false;
        //device.RenderState.AlphaBlendEnable = true;
        //device.RenderState.SourceBlend = Blend.One;
        //device.RenderState.DestinationBlend = Blend.One;

        //device.SetTexture(0, particleTexture);
        //particleSystem.Render(device);

        // Set the render states for using point sprites
        /*				device.RenderState.PointSpriteEnable = true;
                        device.RenderState.PointScaleEnable = true;
                        device.RenderState.PointSize = 0.02f;
                        device.RenderState.PointSizeMin = 0.00f;
                        device.RenderState.PointScaleA = 0.0f;
                        device.RenderState.PointScaleB = 0.0f;
                        device.RenderState.PointScaleC = 1.0f;
                        device.VertexFormat = CustomVertex.PositionColored.Format;*/
        //device.RenderState.FillMode = FillMode.WireFrame;
        /*
        device.RenderState.CullMode = Cull.None;
        device.VertexFormat = CustomVertex.PositionColored.Format;
        CustomVertex.PositionColored[] verts = new CustomVertex.PositionColored[3];
        verts[0].SetPosition(new Vector3(0.0f, 1.0f, 1.0f));
        verts[0].Color = System.Drawing.Color.Red.ToArgb();
        verts[1].SetPosition(new Vector3(-1.0f, -1.0f, 1.0f));
        verts[1].Color = System.Drawing.Color.Turquoise.ToArgb();
        verts[2].SetPosition(new Vector3(1.0f, -1.0f, 1.0f));
        verts[2].Color = System.Drawing.Color.White.ToArgb();
        device.DrawUserPrimitives(PrimitiveType.PointList, 1, verts);
        */
        //Console.WriteLine("Zeichnen");

        // Set up the vertex buffer to be rendered
        /*
                device.RenderState.ZBufferWriteEnable = false;
                device.RenderState.AlphaBlendEnable = true;
                device.RenderState.SourceBlend = Blend.One;
                device.RenderState.DestinationBlend = Blend.One;
                device.SetTexture(0, particleTexture);
                device.RenderState.PointSpriteEnable = true;
                device.RenderState.PointScaleEnable = true ;
                device.RenderState.PointSize = 0.5f;
                device.RenderState.PointSizeMin = 0.0f;
                device.RenderState.PointScaleA = 0.0f;
                device.RenderState.PointScaleB = 0.0f;
                device.RenderState.PointScaleC = 1.0f;
        */
        //Console.WriteLine("Render");

        //Console.WriteLine("i:" + i + " " + r);

        device.RenderState.FillMode=FillMode.Solid;
        device.RenderState.CullMode=Cull.Clockwise;
        //device.RenderState.ShadeMode = ShadeMode.Gouraud;

        //pyramid.DrawSubset(0);
        //meshclean.DrawSubset(0);
        //meshgen.DrawSubset(0);
        //meshgenerated.DrawSubset(0);
        //simplifiedMesh.DrawSubset(0);
        //meshload.DrawSubset(0);

        mesharr[d].DrawSubset(0);

        if(q>300)
        {
            d++;

            if(d==15)
            {
                d=0;
            }

            q=0;
        }

        q++;

        //meshgenerated.DrawSubset(0);
        //meshgeniextern.DrawSubset(0);
        //surfacemesh.DrawSubset(0);
        /*
        device.SetStreamSource(0, vertexBuffer1, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
    
        device.SetStreamSource(0, vertexBuffer2, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
    
        device.SetStreamSource(0, vertexBuffer3, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
        device.SetStreamSource(0, vertexBuffer4, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
        
        device.SetStreamSource(0, vertexBuffer5, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
        device.SetStreamSource(0, vertexBuffer6, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
        device.SetStreamSource(0, vertexBuffer7, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
        device.SetStreamSource(0, vertexBuffer8, 0);
        device.DrawPrimitives(PrimitiveType.PointList, 0, 1000000);
        
        */

        // Reset render states
        //device.RenderState.PointSpriteEnable = false;
        //device.RenderState.PointScaleEnable = false;

        //device.RenderState.ZBufferWriteEnable = true;
        //device.RenderState.AlphaBlendEnable = false;

        // Output statistics

        drawingFont.DrawText(2, 1, System.Drawing.Color.HotPink, frameStats);
        //drawingFont.DrawText(2, 20, System.Drawing.Color.Green, vertices.GetLength(0).ToString());
        /*
        drawingFont.DrawText(2, 20, System.Drawing.Color.Green, deviceStats);

        if(shouldDrawHelp)
        {
            drawingFontSmall.DrawText(2, 40, System.Drawing.Color.White, "Keyboard controls:");
            drawingFontSmall.DrawText(20,
                                      60,
                                      System.Drawing.Color.White,
                                      "Move\nTurn\nPitch\nSlide\n\nHelp\nChange device\nAnimate emitter\nChange color\nCycle Colors\n\nToggle reflection\nExit");
            drawingFontSmall.DrawText(210, 60, System.Drawing.Color.White,
                                      "W,S\nE,Q\nA,Z\nArrow keys\n\nF1\nF2\nF3\nF4\nC\n\nR\nEsc");
        }
        else
        {
            drawingFontSmall.DrawText(2, 40, System.Drawing.Color.White, "Press F1 for help");
        }
        */
        device.EndScene();

    /*if(q>20)
    {
        LoadMesh(d);
        d++;
        if(d==20)
        {
            d=0;
        }
        q=0;
    }
    q++;*/

    /*
                i++;
                if ( i > 1)
                {
                    /*
                    j += numParticlesToRender;
                    a = (float) Math.Round(a+=0.1f, 1);
                    b = 0.1f;
                        
                    numParticlesToRender = (int) Math.Round(System.Math.Pow(10*a,3));
                    //numParticlesToRender += 1;
    
                    //Console.WriteLine("a:" + a + " b:" + b + " numParticlesToRender:" + numParticlesToRender + " j:" + j);
                    */
    //Thread t0 = new Thread(new ThreadStart(ChangeColors));
    //t0.Start();
    //ChangeColors();
    //Thread t1 = new Thread(new ThreadStart(UpdateVertexBuffer));
    //t1.Start();
    //UpdateVertexBuffer();
    //g++;
    //i=0;

    //}

    /*
    i++;
    if ( i > 200)
    {
        Surface backbuffer = device.GetBackBuffer(0, 0, BackBufferType.Mono);
        SurfaceLoader.Save("Screenshot" + j + ".bmp", ImageFileFormat.Jpg, backbuffer);
        backbuffer.Dispose();
        i=0;
        j++;

    }
    */
    }

    void ChangeColors ()
    {
        if(++particleColor==ParticleColors.NumColors)
            particleColor=ParticleColors.White;

        for(int i = 0; i<vertices.GetLength(0); i++)
        {
            vertices[i].color=colors[(int)particleColor].ToArgb();
        }
    }

    void CreateData ()
    {
        //Console.WriteLine("CreateData");
        //vertices = new PointVertex[numParticlesToRender];

        int i = 0;

        /*if (++particleColor == ParticleColors.NumColors)
            particleColor = ParticleColors.White;

        System.Drawing.Color col = colors[(int)particleColor];
        */

        System.Drawing.Color col;
        System.Drawing.Color coltemp = System.Drawing.Color.Violet;
        String str = "0";

        for(float x = 0.0f; x<a; x=(float)Math.Round(x+=b, 3))
        {
            for(float y = 0.0f; y<a; y=(float)Math.Round(y+=b, 3))
            {
                for(float z = 0.0f; z<a; z=(float)Math.Round(z+=b, 3))
                {
                    str=i.ToString();

                    //Console.WriteLine("a:" + a + " b:" + b + " numParticlesToRender:" + numParticlesToRender + " x:" + x + " y:" + y + " z:" + z);
                    switch(str)
                    {
                        case "0":
                            col=System.Drawing.Color.Red;

                            Console.WriteLine("Red: "+col.ToArgb());
                            coltemp=col;
                            break;

                        case "1000000":
                            col=System.Drawing.Color.LightBlue;

                            Console.WriteLine("LightBlue: "+col.ToArgb());
                            coltemp=col;
                            break;

                        case "2000000":
                            col=System.Drawing.Color.Yellow;

                            Console.WriteLine("Black: "+System.Drawing.Color.Black.ToArgb());
                            coltemp=col;
                            break;

                        case "3000000":
                            col=System.Drawing.Color.LightGreen;

                            Console.WriteLine("LightGreen: "+col.ToArgb());
                            coltemp=col;
                            break;

                        case "4000000":
                            col=System.Drawing.Color.White;

                            Console.WriteLine("White: "+col.ToArgb());
                            coltemp=col;
                            break;

                        case "5000000":
                            col=System.Drawing.Color.Violet;

                            coltemp=col;
                            break;

                        case "6000000":
                            col=System.Drawing.Color.YellowGreen;

                            coltemp=col;
                            break;

                        case "7000000":
                            col=System.Drawing.Color.Silver;

                            coltemp=col;
                            break;

                        default:
                            col=coltemp;

                            break;
                    }

                    vertices[i].v=new Vector3(x, y, z);
                    vertices[i].color=col.ToArgb();
                    i++;
                }
            }
        }
    }

    void UpdateVertexBuffer ()
    {
        //vertexBuffer.Dispose();
        //vertexBuffer = null;

        //CustomVertex.PositionColored[] verts = (CustomVertex.PositionColored[]) buf.Lock(0, 0);

        /*
                vertexBuffer = new VertexBuffer(typeof(CustomVertex.PositionColored),
                    numParticlesToRender,
                    device,
                    Usage.WriteOnly | Usage.Points,
                    CustomVertex.PositionColored.Format,
                    Pool.Default);
                ;
                */

        //CustomVertex.PositionColored[] verts = (CustomVertex.PositionColored[]) vertexBuffer.Lock(0, 0);
        //int index = vertices.GetLength(0);
        //int multiplicator = DXHelp.GetTypeSize(typeof(CustomVertex.PositionColored));
        //Console.WriteLine("index: " + index + " multiplicator:" + multiplicator);

        PointVertex []verticestemp = new PointVertex[1000000];
        int h = 1;
        String hhh;

        for(int i = 0; i<8000000; i+=1000000)
        {
            Array.Copy(vertices, i, verticestemp, 0, 1000000);

            hhh=h.ToString();
            //Console.WriteLine("switch anfang: " + hhh);

            switch(hhh)
            {
                case "1":
                    //Console.WriteLine(h);
                    GraphicsStream stream1 = vertexBuffer1.Lock(0, 0, LockFlags.NoOverwrite);

                    stream1.Write(verticestemp);
                    vertexBuffer1.Unlock();
                    h++;
                    break;

                case "2":
                    //Console.WriteLine(h);
                    GraphicsStream stream2 = vertexBuffer2.Lock(0, 0, LockFlags.NoOverwrite);

                    stream2.Write(verticestemp);
                    vertexBuffer2.Unlock();
                    h++;
                    break;

                case "3":
                    //Console.WriteLine(h);
                    GraphicsStream stream3 = vertexBuffer3.Lock(0, 0, LockFlags.NoOverwrite);

                    stream3.Write(verticestemp);
                    vertexBuffer3.Unlock();
                    h++;
                    break;

                case "4":
                    //Console.WriteLine(h);
                    GraphicsStream stream4 = vertexBuffer4.Lock(0, 0, LockFlags.NoOverwrite);

                    stream4.Write(verticestemp);
                    vertexBuffer4.Unlock();
                    h++;
                    break;

                case "5":
                    //Console.WriteLine(h);
                    GraphicsStream stream5 = vertexBuffer5.Lock(0, 0, LockFlags.NoOverwrite);

                    stream5.Write(verticestemp);
                    vertexBuffer5.Unlock();
                    h++;
                    break;

                case "6":
                    //Console.WriteLine(h);
                    GraphicsStream stream6 = vertexBuffer6.Lock(0, 0, LockFlags.NoOverwrite);

                    stream6.Write(verticestemp);
                    vertexBuffer6.Unlock();
                    h++;
                    break;

                case "7":
                    //Console.WriteLine(h);
                    GraphicsStream stream7 = vertexBuffer7.Lock(0, 0, LockFlags.NoOverwrite);

                    stream7.Write(verticestemp);
                    vertexBuffer7.Unlock();
                    h++;
                    break;

                case "8":
                    //Console.WriteLine(h);
                    GraphicsStream stream8 = vertexBuffer8.Lock(0, 0, LockFlags.NoOverwrite);

                    stream8.Write(verticestemp);
                    vertexBuffer8.Unlock();
                    h++;
                    break;
            }

        //Console.WriteLine("switch fetich");

        //stream.Close();
        //stream.InternalData

        //vertexBuffer.SetData(verts, 0, LockFlags.None);
        }
    //Console.WriteLine("for fetich");

    }

    /// <summary>
    /// Update camera
    /// </summary>
    void UpdateCamera ()
    {
        float fElapsedTime;

        if(elapsedTime>0.0f)
            fElapsedTime=elapsedTime;
        else
            fElapsedTime=0.05f;

        float fSpeed = 20.0f*fElapsedTime;
        float fAngularSpeed = 5.0f*fElapsedTime;

        // De-accelerate the camera movement (for smooth motion)
        velocity*=0.9f;
        yawVelocity*=0.9f;
        pitchVelocity*=0.9f;

        // Process keyboard input
        if(keyValues[(int)Keys.Left]!=0 || keyValues[(int)Keys.NumPad1]!=0)
            velocity.X-=fSpeed;    // Slide Left

        if(keyValues[(int)Keys.Right]!=0 || keyValues[(int)Keys.NumPad3]!=0)
            velocity.X+=fSpeed;    // Slide Right

        if(keyValues[(int)Keys.Down]!=0)
            velocity.Y-=fSpeed;    // Slide Down

        if(keyValues[(int)Keys.Up]!=0)
            velocity.Y+=fSpeed;    // Slide Up

        if(keyValues['W']!=0)
            velocity.Z+=fSpeed;    // Move Forward

        if(keyValues['S']!=0)
            velocity.Z-=fSpeed;    // Move Backward

        if(keyValues['A']!=0 || keyValues[(int)Keys.NumPad8]!=0)
            pitchVelocity-=fSpeed; // Pitch Down

        if(keyValues['Z']!=0 || keyValues[(int)Keys.NumPad2]!=0)
            pitchVelocity+=fSpeed; // Pitch Up

        if(keyValues['E']!=0 || keyValues[(int)Keys.NumPad6]!=0)
            yawVelocity+=fSpeed;   // Turn Right

        if(keyValues['Q']!=0 || keyValues[(int)Keys.NumPad4]!=0)
            yawVelocity-=fSpeed;   // Turn Left

        // Update the position vector
        Vector3 vT = velocity*fSpeed;
        vT=Vector3.TransformNormal(vT, orientationMatrix);
        position+=vT;

        if(position.Y<1.0f)
            position.Y=1.0f;

        // Update the yaw-pitch-rotation vector
        yaw+=fAngularSpeed*yawVelocity;
        pitch+=fAngularSpeed*pitchVelocity;

        if(pitch<0.0f)
            pitch=0.0f;

        if(pitch>(float)Math.PI/2)
            pitch=(float)Math.PI/2;

        // Set the view matrix
        Quaternion qR = Quaternion.RotationYawPitchRoll(yaw, pitch, 0.0f);
        orientationMatrix.AffineTransformation(1.25f, new Vector3(0, 0, 0), qR, position);
        viewMatrix=Matrix.Invert(orientationMatrix);
    }

    /// <summary>
    /// The device has been created.  Resources that are not lost on
    /// Reset() can be created here -- resources in Pool.Managed,
    /// Pool.Scratch, or Pool.SystemMemory.  Image surfaces created via
    /// CreateImageSurface are never lost and can be created here.  Vertex
    /// shaders and pixel shaders can also be created here as they are not
    /// lost on Reset().
    /// </summary>
    protected override void InitializeDeviceObjects ()
    {
        Console.WriteLine("InitializeDeviceObjects");
        int tesp = Caps.MaxPrimitiveCount;
        //Console.WriteLine("MaxPrimitiveCount" + tesp);
        drawingFont.InitializeDeviceObjects(device);
        drawingFontSmall.InitializeDeviceObjects(device);

        // Check if we can do the reflection effect
        canDoALphaBlend=(Caps.SourceBlendCaps.SupportsSourceAlpha)
                            && (Caps.DestinationBlendCaps.SupportsInverseSourceAlpha);

        if(canDoALphaBlend)
            canDrawReflection=true;

        vertexBuffer1=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer2=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer3=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer4=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer5=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer6=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer7=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
        vertexBuffer8=new VertexBuffer(typeof(CustomVertex.PositionColored), 1000000,
                                       device,                               Usage.WriteOnly | Usage.Points,
                                       CustomVertex.PositionColored.Format,  Pool.Managed);
        ;
    }

    /// <summary>
    /// The device exists, but may have just been Reset().  Resources in
    /// Pool.Default and any other device state that persists during
    /// rendering should be set here.  Render states, matrices, textures,
    /// etc., that don't change during rendering can be set once here to
    /// avoid redundant state setting during Render() or FrameMove().
    /// </summary>
    protected override void RestoreDeviceObjects (System.Object sender, System.EventArgs e)
    {
        Console.WriteLine("RestoreDeviceObjects");
        // Set the world matrix
        device.Transform.World=Matrix.Identity;

        // Set projection matrix
        float fAspect = ((float)device.PresentationParameters.BackBufferWidth)
                            /device.PresentationParameters.BackBufferHeight;

        device.Transform.Projection=Matrix.PerspectiveFovLH((float)Math.PI/4, fAspect, 0.1f, 500.0f);

        device.SamplerState[0].MinFilter=TextureFilter.Linear;
        device.SamplerState[0].MagFilter=TextureFilter.Linear;
        device.TextureState[0].ColorOperation=TextureOperation.Modulate;
        device.TextureState[0].AlphaOperation=TextureOperation.Modulate;
        device.TextureState[1].ColorOperation=TextureOperation.Disable;
        device.TextureState[1].AlphaOperation=TextureOperation.Disable;

        device.RenderState.SourceBlend=Blend.One;
        device.RenderState.DestinationBlend=Blend.One;
        device.RenderState.Lighting=false;
        device.RenderState.CullMode=Cull.CounterClockwise;
        device.RenderState.ShadeMode=ShadeMode.Flat;

        // Initialize the particle system
        //UpdateVertexBuffer();
        //GenMeshes(device);
        //MeshGenerator(device);
        //MakePyramide(device);
        //GenerateMesh(device);
        LoadMesh();
    }

    /// <summary>
    /// Called during device initialization, this code checks the device for some 
    /// minimum set of capabilities
    /// </summary>
    protected override bool ConfirmDevice (Caps caps, VertexProcessingType vertexProcessingType, Format adapterFormat,
                                           Format backBufferFormat)
    {
        Console.WriteLine("ConfirmDevice");

        // Need to support post-pixel processing (for alpha blending)
        if(!Manager.CheckDeviceFormat(caps.AdapterOrdinal,  caps.DeviceType,
                                      adapterFormat,        Usage.RenderTarget | Usage.QueryPostPixelShaderBlending,
                                      ResourceType.Surface, backBufferFormat))
        {
            return false;
        }

        // Make sure device can do ONE:ONE alphablending
        if(!caps.SourceBlendCaps.SupportsOne)
            return false;

        if(!caps.DestinationBlendCaps.SupportsOne)
            return false;

        // Make sure HW TnL devices can do point sprites
        if((vertexProcessingType==VertexProcessingType.Hardware) || (vertexProcessingType==VertexProcessingType.Mixed))
        {
            if(caps.MaxPointSize<=1.0f)
                return false;
        }

        return true;
    }

    /// <summary>
    /// Event Handler for windows messages
    /// </summary>
    private void OnPrivateKeyUp (object sender, System.Windows.Forms.KeyEventArgs e)
    {
        keyValues[(int)e.KeyCode]=0;

        if(e.KeyCode==System.Windows.Forms.Keys.F1)
            shouldDrawHelp=!shouldDrawHelp;
    }

    /// <summary>
    /// Event Handler for windows messages
    /// </summary>
    private void OnPrivateKeyDown (object sender, System.Windows.Forms.KeyEventArgs e)
    {
        keyValues[(int)e.KeyCode]=1;
    }

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    static void Main ()
    {
        Console.WriteLine("Main");

        using (MyGraphicsSample d3dApp = new MyGraphicsSample())
        {
            if(d3dApp.CreateGraphicsSample())
                d3dApp.Run();
        }
    }
}
}
